'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _defineProperty4 = require('babel-runtime/core-js/object/define-property');

var _defineProperty5 = _interopRequireDefault(_defineProperty4);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _pipeline = require('../pipeline');

var pipeline = _interopRequireWildcard(_pipeline);

var _graphCrdt = require('graph-crdt');

var _root = require('./root');

var _root2 = _interopRequireDefault(_root);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Asynchronous node interface.
 * @class
 */
var Context = function (_Node) {
  (0, _inherits3.default)(Context, _Node);

  /**
   * Creates a new context.
   * @param {Object} root - The root database instance.
   * @param {Object} [node] - Node configurations.
   */
  function Context(root, node) {
    (0, _classCallCheck3.default)(this, Context);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Context.__proto__ || (0, _getPrototypeOf2.default)(Context)).call(this, node));

    _this.root = root;

    if (root) {
      var config = root[_root2.default.configuration];
      var extend = config.extend.context;
      (0, _keys2.default)(extend).forEach(function (key) {
        var value = extend[key];

        (0, _defineProperty5.default)(_this, key, { value: value });
      });
    }
    return _this;
  }

  /**
   * Reads a list of fields. Pointers are resolved efficiently using `db.nodes`.
   * @param  {String[]} fieldNames - The fields to read.
   * @param  {Object} [options] - Read options.
   * @return {Promise<Array<*>>} - All the corresponding fields.
   */


  (0, _createClass3.default)(Context, [{
    key: 'fields',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(fieldNames) {
        var _this2 = this;

        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        var settings, config, edges, edgeFields, pointers, results, nodes, fields, result;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                settings = this.root[_root2.default.configuration];
                _context.next = 3;
                return pipeline.before.read.fields(settings, (0, _extends3.default)({}, options, {
                  fields: fieldNames,
                  node: this
                }));

              case 3:
                config = _context.sent;


                // Find all the pointers.
                edges = config.fields.reduce(function (nodes, field) {
                  var value = _this2.value(field);

                  if (value && (typeof value === 'undefined' ? 'undefined' : (0, _typeof3.default)(value)) === 'object') {
                    nodes[field] = value;
                  }

                  return nodes;
                }, {});

                // Get the corresponding field names of each pointer.

                edgeFields = (0, _keys2.default)(edges);

                // Associative array of node pointers.

                pointers = edgeFields.map(function (field) {
                  return edges[field].edge;
                });

                // Resolve all the pointers at once, unless there aren't any.

                if (!pointers.length) {
                  _context.next = 13;
                  break;
                }

                _context.next = 10;
                return this.root.nodes(pointers, config);

              case 10:
                _context.t0 = _context.sent;
                _context.next = 14;
                break;

              case 13:
                _context.t0 = [];

              case 14:
                results = _context.t0;


                // Reassemble them into their key/value pairs.
                nodes = {};

                edgeFields.forEach(function (field, index) {
                  nodes[field] = results[index];
                });

                // Give the fields back in the order they were requested.
                fields = config.fields.map(function (field) {
                  if (edges[field]) {
                    return nodes[field];
                  }

                  return _this2.value(field);
                });
                _context.next = 20;
                return pipeline.after.read.fields(settings, (0, _extends3.default)({}, config, {
                  fields: fields
                }));

              case 20:
                result = _context.sent;
                return _context.abrupt('return', result.fields);

              case 22:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function fields(_x) {
        return _ref.apply(this, arguments);
      }

      return fields;
    }()

    /**
     * Reads a value from the node.
     * @param  {String} field - The field to read.
     * @param  {String} [options] - Plugin-level options.
     * @return {Promise} - Resolves to the value or undefined.
     */

  }, {
    key: 'read',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(field, options) {
        var _ref3, _ref4, result;

        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.fields([field], options);

              case 2:
                _ref3 = _context2.sent;
                _ref4 = (0, _slicedToArray3.default)(_ref3, 1);
                result = _ref4[0];
                return _context2.abrupt('return', result);

              case 6:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function read(_x3, _x4) {
        return _ref2.apply(this, arguments);
      }

      return read;
    }()

    /**
     * Writes a value to the node.
     * @param  {String} field - Where to write the data.
     * @param  {Mixed} value - A value to write.
     * @return {Promise} - Resolves when the value has written successfully.
     */

  }, {
    key: 'write',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(field, value) {
        var delta, update;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:

                /** It's a reference. Save as a pointer. */
                if (value instanceof _graphCrdt.Node) {
                  value = { edge: String(value) };
                }

                /** Create a node delta. */
                delta = this.new();

                /** Bump the state if it exists. */

                if (this.state(field)) {
                  delta.merge((0, _defineProperty3.default)({}, field, this.value(field)));
                  delta.meta(field).state = this.state(field);
                }

                /** Apply the field update. */
                delta.merge((0, _defineProperty3.default)({}, field, value));

                /** Create a graph delta. */
                update = _graphCrdt.Graph.source((0, _defineProperty3.default)({}, this.meta().uid, delta));

                /** Commit the update. */

                _context3.next = 7;
                return this.root.commit(update);

              case 7:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function write(_x5, _x6) {
        return _ref5.apply(this, arguments);
      }

      return write;
    }()

    /**
     * Creates a copy of the context.
     * @return {Context} - A new context with the same uid and root.
     */

  }, {
    key: 'new',
    value: function _new() {
      var config = this.meta();

      return new Context(this.root, config);
    }
  }]);
  return Context;
}(_graphCrdt.Node);

exports.default = Context;